<template>
  <p class="relative">
    <input
      :id="id"
      v-model="data"
      :placeholder="title"
      :autocomplete="autocomplete"
      :type="type"
      class="peer w-full border-b border-fuchsia-50 pt-4 text-lg font-normal antialiased caret-fuchsia-500 outline-none transition-colors placeholder:text-transparent hover:border-fuchsia-300 focus-visible:border-fuchsia-500"
      @blur="$emit('blur', $event)"
      @focus="$emit('focus', $event)"
      @input="$emit('input', $event)"
    />
    <label
      :for="id"
      class="pointer-events-none absolute -top-1 left-0 text-sm font-normal text-slate-500 transition-all peer-placeholder-shown:top-4 peer-placeholder-shown:text-lg"
    >
      {{ title }}
    </label>
    <slot />
  </p>
</template>

<script lang="ts" setup>
type Props = {
  title: string;
  modelValue: string;
  autocomplete?:
    | 'on'
    | 'off'
    | 'name'
    | 'email'
    | 'username'
    | 'current-password'
    | 'new-password';
  type?: 'text' | 'password' | 'email';
};

const props = withDefaults(defineProps<Props>(), {
  autocomplete: 'off',
  type: 'text',
});

const emit = defineEmits<{
  (e: 'update:modelValue', id: string): void;
  (e: 'focus', id: Event): void;
  (e: 'blur', id: Event): void;
  (e: 'input', id: Event): void;
}>();

const id = computed<string>(() => `${props.title}_${props.type}`);
const data = ref(props.modelValue);

watch(data, () => emit('update:modelValue', data.value));
</script>
